<?php
	class Calendarista_Admin{
		private $generalSetting;
		public function __construct(){
			$this->generalSetting = Calendarista_GeneralSettingHelper::get();
			add_action('init', array($this, 'init'));
			add_action('admin_menu', array($this, 'menu'));
			add_action('wp_head', array($this, 'metaData'));
			add_action('wp_loaded', array($this, 'wpLoaded'));
			new Calendarista_RegisterJobs();
		}
		public function init() {
			Calendarista_TranslationHelper::registerEmailResource();
			new Calendarista_ExpiredErrorLogJob();
			new Calendarista_FeedSynchJob();
			new Calendarista_GoogleCalendarJob();
			new Calendarista_WooCommerceJob();
		}
		public function menu() {
			new Calendarista_RegisterAdminMenuAndAssets();
		}
		public function metaData(){
			echo '<meta name="plugins" content="calendarista ' . esc_html(CALENDARISTA_VERSION) . '" />';
		}
		public function wpLoaded(){
			//do any serverside redirections here, otherwise it's too late in the wp life cycle.
			new Calendarista_RedirectController();
		}
	}
?>
