<?php
class Calendarista_FeedList extends Calendarista_List {
	public $perPage;
	public $orderBy;
	public $order;
	public $totalPages;
	public $count;
	function __construct( ){
		$this->perPage = 10;
        parent::__construct( array(
            'singular'  => 'feed', 
            'plural'    => 'feed', 
            'ajax'      => false    
        ) );
    }
	
	function single_row( $item ) {
		static $row_class = '';
		$row_class = ( $row_class == '' ? 'alternate' : '' );
		$id = isset($_GET['id']) ? (int)$_GET['id'] : null;
		if($item['id'] == $id){
			$row_class .= ' table-selected-row';
		}
		$row_class = $row_class ? ' class="' . $row_class . '"' : '';
		echo '<tr' . esc_attr($row_class) . '>';
		echo wp_kses_post($this->single_row_columns( $item ));
		echo '</tr>';
	}
	
    function column_default($item, $column_name){
        switch($column_name){
            default:
                return print_r($item,true); 
        }
    }
	function column_action($item){
		$result = array(
			sprintf('<input type="hidden" name="projectId_%d" value="%d">', $item['id'], $item['projectId'])
			, sprintf('<input type="hidden" name="availabilityId_%d" value="%d">', $item['id'], $item['availabilityId'])
		);
		array_push($result, '<br>');
		array_push($result, sprintf(
			'<button type="submit" class="button button-primary" name="calendarista_delete" 
				value="%d">
				%s
			</button>'
			, $item['id']
			, __('Delete Feed', 'calendarista')
		));
		array_push($result, '<br>');
		array_push($result, sprintf(
			'<button type="submit" class="button button-primary" title="%s" name="calendarista_delete_sync_data" 
				value="%d">
				%s
			</button>'
			, __('Delete Feed + Sync data', 'calendarista')
			, $item['id']
			, __('Delete All', 'calendarista')
		));
        return join("\n", $result);
	}
	function column_ck($item){
		return sprintf('<input type="checkbox" name="feeds[]" value="%d">', $item['id']);
	}
	function column_feedUrl($item){
		return $item['feedUrl'];
	}
	function column_projectName($item){
		return $item['projectName'];
	}
	function column_availabilityName($item){
		return isset($item['availabilityId']) ?  $item['availabilityName'] : __('Any', 'calendarista');
	}
	
    function get_columns(){
        $columns = array(
			'ck'=>'<input type="checkbox" name="selectall">'
			, 'feedUrl'=>__('Feed URL', 'calendarista')
			, 'projectName'=>__('Service', 'calendarista')
			, 'availabilityName'=>__('Availability', 'calendarista')
			, 'action'=>__('Action', 'calendarista')
        );
        return $columns;
    }
    
    function get_sortable_columns() {
		//true means its already sorted
        $sortable_columns = array(
			'feedUrl'=>array('id', true)
            , 'projectName'=> array('projectId', false)
			, 'availabilityName'=> array('availabilityId', false)
        );
        return $sortable_columns;
    }
    
    /**
		@description binds to data
	*/
    function bind() {
        $columns = $this->get_columns();
        $hidden = array();
        $sortable = $this->get_sortable_columns();
        $this->_column_headers = array($columns, $hidden, $sortable);
        $currentPage = $this->get_pagenum() - 1;
		if($currentPage){
			$currentPage = $currentPage * $this->perPage;
		}
		$allowedKeys = array('id', 'projectId', 'availabilityId', 'asc', 'desc');
        $this->orderBy = (!empty($_REQUEST[$this->orderByKey])) ? sanitize_text_field($_REQUEST[$this->orderByKey]) : 'id';
		if (!in_array($this->orderBy, $allowedKeys, true)) {
			return;
		}
        $this->order = (!empty($_REQUEST[$this->orderKey])) ? sanitize_text_field($_REQUEST[$this->orderKey]) : 'desc'; 
		if (!in_array($this->order, $allowedKeys, true)) {
			return;
		}
		$staffMemberAvailabilities = Calendarista_PermissionHelper::staffMemberAvailabilities();
		$feedRepository = new Calendarista_FeedsRepository();
        $result = $feedRepository->readAll(array(
			'pageIndex'=>$currentPage
			, 'limit'=>$this->perPage
			, 'orderBy'=>$this->orderBy
			, 'order'=>$this->order
			, 'availabilities'=>$staffMemberAvailabilities
		));
		$this->currentPage = $currentPage;
        $this->count = $result['total'];
        $this->items = $result['items'];
		if(!$this->count){
			return;
		}
		$this->totalPages = ceil($this->count / $this->perPage);
        $this->set_pagination_args( array(
            'total_items' => $this->count,
            'per_page'    => $this->perPage,
            'total_pages' => $this->totalPages
        ) );
    }
	
	function get_table_classes() {
		return array('wp-list-table', 'calendarista',  'widefat', 'fixed', 'striped', 'calendarista-feed-list');
	}
	public function no_items() {
		esc_html_e('No feeds to import found.', 'calendarista');
	}
}
?>