<?php
class Calendarista_UpdatesRequestHelper{
	private function __construct() { }
	//calendarista-updates
	public static function verify($code){
		$verifyUrl = 'https://updates.calendarista.com/verify.php?code='.$code;
		return self::request($code, $verifyUrl);
	}
	public static function test($code){
		$testUrl = 'https://updates.calendarista.com/rs.php?code='.$code;
		return self::request($code, $testUrl);
	}
    public static function request($code, $url){
		//setting the header for the rest of the api
		$header   = array();
		$header[] = 'Content-length: 0';
		$header[] = 'Content-type: text/plain; charset=utf-8';
		
		$response = wp_remote_get($url, array(
			'headers'=>$header, 
			'timeout'=> '100'
		));
		$result = null;
		if (is_array($response) && !is_wp_error($response)) {
			$result = $response['body'];
		}else {
			if(is_wp_error($response)){
				$message = $response->get_error_message();
				Calendarista_ErrorLogHelper::insert("cURL error: $message");
			}
			return false;
		}
		if ($result){
			return (int)$result; 
		}
		return false;
    }
}
?>